------------------------------------------------------------------------------------------
-- UI file
-- Written by Homeopatix
-- 26 january 2021
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
-- Initialize datas
------------------------------------------------------------------------------------------

------------------------------------------------------------------------------------------
-- create the main window
------------------------------------------------------------------------------------------
function CreateBarWindow()
	AltHolicBar=Turbine.UI.Extensions.SimpleWindow(); 
	AltHolicBar:SetSize(screenWidth, 50); 
	AltHolicBar:SetBackColor(Turbine.UI.Color.Black);
	AltHolicBar:SetPosition(0, 0);
	AltHolicBar:SetVisible(settings["displayBarWindow"]["value"]);
	AltHolicBar:SetZOrder(1);
	AltHolicBar:SetOpacity(0.75);
	AltHolicBar:SetWantsKeyEvents(true);
	AltHolicBar:SetWantsUpdates(true);
	AltHolicBar:SetMouseVisible(true);

	DisplayNamePlayer_Bar();

	if(settings["displayBarIcon2"]["value"] == true)then
		DisplayLvlPlayer_Bar();
	end
	if(settings["displayBarIcon4"]["value"] == true)then
		DisplayClassPlayer_Bar();
	end
	if(settings["displayBarIcon3"]["value"] == true)then
		DisplayRacePlayer_Bar();
	end
	if(settings["displayBarIcon5"]["value"] == true)then
		DisplayServerPlayer_Bar();
	end
	if(settings["displayBarIcon6"]["value"] == true)then
		DisplayCashOfPlayer_Bar();
	end
	if(settings["displayBarIcon7"]["value"] == true)then
		DisplayWalletButton_Bar();
	end
	if(settings["displayBarIcon8"]["value"] == true)then
		DisplayVaultButton_Bar();
	end
	if(settings["displayBarIcon9"]["value"] == true)then
		DisplayBagButton_Bar();
	end
	if(settings["displayBarIcon10"]["value"] == true)then
		DisplayButtonVocation_Bar();
	end
	if(settings["displayBarIcon11"]["value"] == true)then
		DisplaySharedStorage_Bar();
	end
	if(settings["displayBarIcon12"]["value"] == true)then
		DisplayEpiqueBook_Bar();
	end
	if(settings["displayBarIcon13"]["value"] == true)then
		DisplayLoupe_Bar();
	end
	if(settings["displayBarIcon14"]["value"] == true)then
		DisplayTotalCash_Bar();
	end
	if(settings["displayBarIcon15"]["value"] == true)then
		DisplaySessionCash_Bar();
	end
	
	DisplayAltHolicIcon_Bar();

	AltHolicBar.MouseClick = function()
		if(settings["isOptionsWindowBarVisible"]["isOptionsWindowBarVisible"] == false)then
			GenerateOptionsWindowBar();
			settings["isOptionsWindowBarVisible"]["isOptionsWindowBarVisible"] = true;
			OptionsWindowBar:SetVisible(true);
		else
			settings["isOptionsWindowBarVisible"]["isOptionsWindowBarVisible"] = false;
			OptionsWindowBar:SetVisible(false);
		end
	end

	hudVisible=true; -- the actual HUD state is not exposed to Lua so we have to assume the HUD is visible when the plugin loads
	if(settings["displayBarWindow"]["value"] == true)then
		UIShowSearchVisible=true;
	else
		UIShowSearchVisible=false;
	end-- used to retain the state of the window for when the HUD is toggled back on

	AltHolicBar.KeyDown=function(sender, args)
		if ( args.Action == 268435635 ) then -- toggle HUD (the HUD action is not defined in the Turbine.UI.Lotro.Action enumeration although it should be)
			hudVisible=not hudVisible;
			if hudVisible then
				UIShowSearchVisible = false ;
				AltHolicBar:SetVisible(UIShowSearchVisible);
			else
				UIShowSearchVisible = true ;
				if(settings["displayBarWindow"]["value"] == true)then
					AltHolicBar:SetVisible(UIShowSearchVisible);
				end
			end
		end
	end
end

function UpdateBar()
	if(settings["displayBarWindow"]["value"] == true)then
		AltHolicBar:SetVisible(false);
		CreateBarWindow();
		AltHolicBar:SetVisible(true);
	else
		AltHolicBar:SetVisible(false);
	end
end